<dx-data-grid class="gridContainer box-shadow" #gridInvoices [columnAutoWidth]='true' [allowColumnResizing]='true'
  [allowColumnReordering]='true' [showColumnLines]='ui.showColumnLines' [showRowLines]='ui.showRowLines'
  [hoverStateEnabled]="true" [dataSource]='dsInvoices' (onToolbarPreparing)='toolbarPreparing($event)' [height]='ui.fullHeight'
  keyExpr='id'>
  <dxo-export [enabled]='true' [enabled]='true' fileName='invoices'></dxo-export>
  <dxo-header-filter [visible]='true'></dxo-header-filter>
  <dxo-group-panel [visible]='true'></dxo-group-panel>
  <dxo-remote-operations [sorting]="true" [paging]="true" [filtering]="true"></dxo-remote-operations>
  <dxo-scrolling mode='virtual' showScrollbar='onHover' [useNative]='true'></dxo-scrolling>
  <dxo-search-panel [visible]='true'></dxo-search-panel>
  <dxo-state-storing [enabled]="true" type="localStorage" storageKey="qhseInvoices"></dxo-state-storing>
  <dxo-filter-row [visible]='true'></dxo-filter-row>
  <dxo-column-chooser [enabled]="true" mode='dragAndDrop'></dxo-column-chooser>
  <dxo-column-fixing [enabled]="true"></dxo-column-fixing>
  <dxo-master-detail [enabled]='true' template='details'></dxo-master-detail>

  <dxi-column [caption]='ds.lg.format("ENTITY")' dataField='entityId' dataType='string'>
    <dxo-lookup [dataSource]='dspEntities' valueExpr='id' displayExpr='name'></dxo-lookup>
  </dxi-column>
  <dxi-column [caption]='ds.lg.format("SUPPLIER")' dataField='supplierId' dataType='string'>
    <dxo-lookup [dataSource]='dspContractors' valueExpr='id' displayExpr='name'></dxo-lookup>
  </dxi-column>
  <dxi-column [caption]='ds.lg.format("NO")' dataField='no' dataType='number' [allowHeaderFiltering]='false'>
  </dxi-column>
  <dxi-column [caption]='ds.lg.format("DATE")' dataField='date' dataType='date' calculateSortValue='date' [calculateDisplayValue]='ds.getDate'>
  </dxi-column>
  <dxi-column caption='Sumă - cu Tva' dataField='amount' dataType='number' [allowHeaderFiltering]='false'>
  </dxi-column>
  <dxi-column caption='Tip factură' dataField='isSales' dataType='boolean' [allowHeaderFiltering]='false'>
    <dxo-lookup [dataSource]='ds.dsInvoiceType' valueExpr='id' displayExpr='value'></dxo-lookup>
  </dxi-column>
  <dxi-column caption='Descriere' dataField='comments' dataType='string' [allowHeaderFiltering]='false'>
  </dxi-column>
  <dxi-column type="buttons" fixedPosition='left' width='110' [fixed]='true' [allowResizing]='false'
    [showInColumnChooser]='false'>
    <dxi-button hint='Editează' icon="edit" [onClick]="onEditInvoicesClick"></dxi-button>
    <dxi-button hint='Șterge' icon='trash' [onClick]="onDeleteInvoicesClick"></dxi-button>
  </dxi-column>

  <div *dxTemplate='let data of "details"'>
    <app-file-upload [gridData]='data'></app-file-upload>
  </div>

</dx-data-grid>

<dx-popup [(visible)]='isInvoicesPopupVisible' [minWidth]='ui.minWidthPopup' width='auto' maxWidth='90vw' (onShown)='ui.onPopupShown($event)'
  (onHidden)='ui.onPopupHidden($event)' height='auto' title='Facturi'>
  <div *dxTemplate="let data of 'content'">
    <dx-scroll-view [height]='ui.scrollHeight' width="auto" direction="both">
      <app-edit-invoice [invoicesData]='invoices'></app-edit-invoice>
    </dx-scroll-view>
  </div>
  <dxi-toolbar-item toolbar="bottom" location="after" widget="dxButton" [options]="{ text:'Salvează', icon:'save', type: 'normal', onClick: onSaveInvoice, validationGroup:'invoiceValidation' }">
  </dxi-toolbar-item>
</dx-popup>